package com.company.demo2.web.app;

import com.haulmont.cuba.gui.navigation.NavigationState;
import com.haulmont.cuba.web.security.ExternalUserCredentials;
import com.vaadin.server.VaadinRequest;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Locale;

public class AppUI extends com.haulmont.cuba.web.AppUI {
    Logger logger= LoggerFactory.getLogger(this.getClass());
    @Override
    protected void processRequest(NavigationState navigationState) {
        super.processRequest(navigationState);
    }

    void externalAuthenticate(String token){
        // 验证token、登录
        Locale local = new Locale("zh","CN");
        ExternalUserCredentials credentials = new ExternalUserCredentials("test", local);
        getApp().getConnection().login(credentials);
    }
    @Override
    protected void processExternalLink(VaadinRequest request, NavigationState requestedState) {
        String token = request.getParameter("token");
        if(!StringUtils.isEmpty(token)){
            try{
                externalAuthenticate(token);
            }catch (Throwable throwable){
                logger.error("外部登录出现异常",throwable);
            }finally {

            }
        }
        super.processExternalLink(request, requestedState);
    }
}
